//
// Created by robtor on 09.12.22.
//

#ifndef FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
#define FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H

#include "Menu_Entry_Type_Delegate.h"
#include "Config_Entry_Type.h"

namespace floatpump {
    namespace menu {

    class Menu_Entry_Type_Checkable : public Menu_Entry_Type_Delegate {
    public:
        Menu_Entry_Type_Checkable(bool mState)
                : m_state(mState) {}

        std::string toString() override {
            return std::string((m_state) ? "ON " : "OFF");
        }

        void u_press() override {
            m_state = !m_state;
        }

        void u_increase(uint16_t steps) override {

        }

        void u_decrease(uint16_t steps) override {

        }

        bool isEntered() override {
            return false;
        }

    private:
        bool m_state = false;
    };

    } // floatpump
} // menu

#endif //FLOATPUMP_MENU_ENTRY_TYPE_CHECKABLE_H
